/*
	BromScript - On Runtime Scripting Language.
    Copyright (C) 2012 - 2013  Alex Brouwer (Bromvlieg: http://brom.4o3.nl/)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef BROMSCRIPT_LIBARY_CONSOLE_INCLUDED
#define BROMSCRIPT_LIBARY_CONSOLE_INCLUDED

#include "SIF.h"
#include <windows.h>
#include <iosfwd>

namespace BromScript{
	namespace Libaries{
		namespace Console{
			enum Colors{
				ColorBlack = 0,
				ColorDarkBlue = 1,
				ColorDarkGreen = 2,
				ColorDarkCyan = 3,
				ColorDarkRed = 4,
				ColorDarkMagenta = 5,
				ColorDarkYellow = 6,
				ColorDarkWhite = 7,
				ColorGray = 8,
				ColorBlue = 9,
				ColorGreen = 10,
				ColorCyan = 11,
				ColorRed = 12,
				ColorMagenta = 13,
				ColorYellow = 14,
				ColorWhite = 15
			};

			static HANDLE std_con_out;
			static Colors textcol, backcol, deftextcol, defbackcol;
			static bool didinit = false;

			BS_FUNCTION(SetForeColor);
			BS_FUNCTION(SetBackColor);
			BS_FUNCTION(SetDefaultColors);
		}
	}
}

#endif